## iotivity 1.3.0

=== Makefile ===
#!/usr/bin/make -f
name?=iotivity

default/%:
	@echo "# $@ ignored"


default: all

# Overide variables
host_arch?=$(shell uname -m || echo "default")
OSTYPE?=$(shell echo "$${OSTYPE}")
uname?=$(shell echo `uname -s` || echo "")

TARGET_OS?=${uname}
ifeq ("",${TARGET_OS})
TARGET_OS=${OSTYPE}
endif

ifeq ("linux-gnu","${TARGET_OS}")
TARGET_OS=linux
endif
ifeq ("Linux","${TARGET_OS}")
TARGET_OS=linux
endif
ifeq ("",${TARGET_OS})
TARGET_OS=default
endif

ifeq ("i386","${host_arch}")
TARGET_ARCH?=x86
else
ifeq ("i486","${host_arch}")
TARGET_ARCH?=x86
else
ifeq ("i586","${host_arch}")
TARGET_ARCH?=x86
else
ifeq ("i686","${host_arch}")
TARGET_ARCH?=x86
else
ifeq ("armel","${host_arch}")
TARGET_ARCH?=arm
else
ifeq ("armhf","${host_arch}")
TARGET_ARCH?=arm
endif
ifeq ("aarch64","${host_arch}")
TARGET_ARCH?=arm64
endif
ifeq ("armv7l","${host_arch}")
TARGET_ARCH?=arm
endif
endif
endif
endif
endif
endif


# Default variables to override:
#release_mode?=0
#secure_mode?=0
#logging_mode?=True

TARGET_ARCH?=${host_arch}
TARGET_OS?=${uname}
TARGET_TRANSPORT?=IP
bindir?=/usr/bin/
includedir?=/usr/include
libdir?=/usr/lib
sbindir?=/usr/sbin

ifeq (0,${release_mode})
build_dir?=debug
debug_mode?=1
else
build_dir?=release
release_mode?=1
debug_mode?=0
endif


config_build?=VERBOSE=1 V=1
config_build+=DEBUG=${debug_mode} RELEASE=${release_mode}
config_build+=TARGET_ARCH=${TARGET_ARCH}
config_build+=TARGET_OS=${TARGET_OS}

# Overide default config if defined
ifneq ("","${logging_mode}")
config_build+=LOGGING=${logging_mode}
endif

ifneq ("","${secure_mode}")
config_build+=SECURED=${secure_mode}
endif

# Default variables to override:
#config_build+=TARGET_TRANSPORT=IP
#config_build+=WITH_TCP=1

outdir?=out/${TARGET_OS}/${TARGET_ARCH}/${build_dir}

all: build

build: SConstruct
	scons ${config_build}

check/%: auto_build.sh
	${<D}/${<F} unit_tests\
 && echo "log: $@: succeeded" \
 || echo "warning: $@: failed and ignored, TODO: fix $@ (and don't ignore $@ failures)"

check/default: auto_build.sh
	${<D}/${<F} unit_tests

check: check/${host_arch}


install:
	scons ${config_build} $@
	${MAKE} rule/install

rule/install: ${outdir} rule/fix rule/install_headers rule/install_examples rule/install/secure_mode/${secure_mode}
	install -d ${DESTDIR}${libdir}
	find $< -iname "lib*.a" -exec install "{}" ${DESTDIR}${libdir}/ \;
	find $< -iname "lib*.so" -exec install "{}" ${DESTDIR}${libdir}/ \;
	-rm -fv ${DESTDIR}${libdir}/lib*.a
	install -d ${DESTDIR}${libdir}/pkgconfig
	install -d ${DESTDIR}/usr/share/pkgconfig
	install ${name}.pc ${DESTDIR}${libdir}/pkgconfig/
	ln -fs ../../../${libdir}/pkgconfig/${name}.pc ${DESTDIR}/usr/share/pkgconfig


clean:
	rm -f *~

rule/fix: ${name}.pc
	sed -e 's|^prefix=.*|prefix=/usr|g' -i ${<}


rule/install_headers: ${outdir}/include
	install -d ${DESTDIR}${includedir}/${name}
	cd $< && find . -type f | while read file ; do \
  dirname=$$(dirname -- "$${file}") ; \
  install -d ${DESTDIR}${includedir}/${name}/$${dirname} ; \
  install $${file} ${DESTDIR}${includedir}/${name}/$${dirname}/ ; \
 done
	@echo "TODO: workaround headers namespaces"
	ln -fs iotivity/resource ${DESTDIR}${includedir}/
	ln -fs iotivity/service ${DESTDIR}${includedir}/
	ln -fs iotivity/c_common ${DESTDIR}${includedir}/

rule/install_examples: ${outdir}
	install -d ${DESTDIR}${libdir}/${name}/examples/cpp/
	install $</resource/examples/* ${DESTDIR}${libdir}/${name}/examples/cpp/
	rm -f ${DESTDIR}${libdir}/${name}/examples/cpp/*.o

rule/install/secure_mode/${secure_mode}:  ${outdir}  rule/install/secure_mode/1
	find $< -type f -executable | grep -v '.so$$'

rule/install/secure_mode/1: ${outdir}
	install -d ${DESTDIR}${bindir}/
	install $</resource/csdk/security/tool/json2cbor ${DESTDIR}${libdir}/${name}/examples/
	install -d ${DESTDIR}${libdir}/${name}/examples/c/secure/
	install $</resource/csdk/stack/samples/linux/secure/* ${DESTDIR}${libdir}/${name}/examples/c/secure/
	rm -f ${DESTDIR}${libdir}/${name}/examples/c/secure/*.o

rule/install/secure_mode/0: ${outdir}
	ls $<

rule/help:
	@echo "OSTYPE=${OSTYPE}"
	@echo "TARGET_OS=${TARGET_OS}"
	@echo "host_arch=${host_arch}"
	@echo "uname=${uname}"

docs_file?=${name}-docs.zip

rule/docs: resource/docs/javadocGen.sh
	rm -rf ${docs_file}
	mkdir -p ${<D}/html
	touch ${<D}/html/footer.html
	cd ${<D} && ./${<F}
	cd ${CURDIR} && zip -r9 ${docs_file} ./${<D}
	find . \
 -iname 'DoxyFile' -printf "%h\n" \
 -o -iname 'extlibs' -prune -a -iname 'out' -prune \
 | while read file ; do \
  cd "${CURDIR}/$${file}" && doxygen ; \
  cd ${CURDIR} ; \
  zip -r9 ${docs_file} $${file} ; \
done

=== SConstruct ===
#******************************************************************
#
# Copyright 2014 Intel Mobile Communications GmbH All Rights Reserved.
#
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

##
# The main build script
#
##
import os

# Load common build config
SConscript('build_common/SConscript')

Import('env')

if os.environ.get('TERM') != None:
	env['ENV']['TERM'] = os.environ['TERM']

# Load extra options
SConscript('extra_options.scons')

target_os = env.get('TARGET_OS')
if target_os == 'arduino':
	SConscript('arduino.scons')

# By default, src_dir is current dir, the build_dir is:
#     ./out/<target_os>/<target_arch>/<release or debug>/
#
# The build_dir is a variant directory of the source directory(You can
# consider build_dir as a soft link to src_dir, for detail please refer to:
#     http://www.scons.org/doc/production/HTML/scons-user.html#f-VariantDir
#
# Any way, to make the output is in build_dir, when load scripts, the path should
# be relevant to build_dir.
build_dir = env.get('BUILD_DIR')

# Build 'resource' sub-project
SConscript(build_dir + 'resource/SConscript')

if target_os not in ['arduino','darwin','ios', 'android', 'msys_nt', 'windows']:
	SConscript(build_dir + 'examples/OICMiddle/SConscript')

java_build = None
if (env.get('BUILD_JAVA') == True  and env.get('JAVA_HOME') != None) or target_os == 'android':
        java_build = SConscript(build_dir + 'java/SConscript')

# Build 'service' sub-project
service_build = SConscript(build_dir + 'service/SConscript')

if (env.get('BUILD_JAVA') == True and env.get('JAVA_HOME') != None) or target_os == 'android':
        Depends(service_build, java_build)

# Build "cloud" sub-project
SConscript(build_dir + 'cloud/SConscript')

# Build "plugin interface" sub-project
SConscript(build_dir + 'plugins/SConscript')

# Build "bridging" sub-project
SConscript(build_dir + 'bridging/SConscript')

# Append targets information to the help information, to see help info, execute command line:
#     $ scon [options] -h
env.PrintTargets()

# Print bin upload command line (arduino only)
if target_os == 'arduino':
	env.UploadHelp()

# to install the generated pc file into custom prefix location
env.UserInstallTargetPCFile('iotivity.pc', 'iotivity.pc')

=== resource/csdk/connectivity/build/tizen/Makefile ===
##
# override with `make BUILD=debug`
# override with `make PLATFORM=arduinomega` or `make PLATFORM=arduinodue`
# default to release build
# default to build for linux
BUILD	 := debug
PLATFORM := tizen
OBJ_DIR := ./bin
ROOT_DIR := .
VERSION_MAJOR := 0
VERSION_MINOR := 1
VERSION_PATCH := 0
ADAPTER_MACRO := -DWIFI_ADAPTER

$(info *******************tizen Build !!******************)

CC=gcc
LIBCOAP=./lib/libcoap-4.1.1/
LIBCOAP_OBJ_DIR=./lib/libcoap-4.1.1/obj

# TODO : Currently Hardcoded WIFI_ADAPTER. Change it to generic
CFLAGS.debug = -DWITH_POSIX -D__TIZEN__ -Wall -std=c99 -DSLP_SDK_LOG -g -D_GNU_SOURCE -DTIZEN_DEBUG_ENABLE -DTB_LOG $(ADAPTER_MACRO)
CFLAGS.release = -DWITH_POSIX -D__TIZEN__ -Wall -std=c99 -DSLP_SDK_LOG -D_GNU_SOURCE -DTIZEN_DEBUG_ENABLE -DTB_LOG $(ADAPTER_MACRO)
COMPILEFLAG = `pkg-config --cflags --libs capi-network-wifi dlog ttrace capi-network-bluetooth glib-2.0`

# Include files will be copied into a single folder on gbsbuild.
# NO NEED to mention the path explicitly.

CA_INC              = $(ROOT_DIR)/
DTLS_INC           = $(ROOT_DIR)/dtls/

INC_DIRS        := -I$(CA_INC)
INC_DIRS        += -I$(DTLS_INC)

SRC = $(wildcard *.c)
OBJECTS = $(patsubst %.c, %.o, $(SRC))

#Currently compiling libcoap objects. If it's provided by external party.
#Then don't compile, Instead directly extract objects and create liboicinterface.a
all: $(OBJECTS)
	$(MAKE) -C $(LIBCOAP) clean
	$(MAKE) -C $(LIBCOAP)
	-mkdir $(LIBCOAP_OBJ_DIR)
	@cd $(LIBCOAP_OBJ_DIR) && $(AR) -x ../libcoap.a
	ar rcs liboicinterface.a $(OBJECTS) $(LIBCOAP_OBJ_DIR)/*.o

%.o : %.c
	$(CC) -c $(CFLAGS.$(BUILD)) $(COMPILEFLAG) $(INC_DIRS) $< -o $@


pack:
#$(CC) $(CFLAGS) $(COMPILEFLAG) WiFiInterface.c bt_interface.c tc_interface.c sample_main.c -o sample /usr/lib/liboctbstack.a -lm -pthread
	$(info **************************************TEST***************************)
install:
#cp -rf sample ./usr/apps/com.samsung.oicca/bin/sample

clean:
	rm -rf *.o sample
	rm -f *.o *.d *.elf *.eep core.a *.hex *.bin *.map *-
	rm -rf $(OBJ_DIR)
	rm -rf $(LIBCOAP_OBJ_DIR)

=== debian/changelog ===
iotivity (1.3.0-0) unstable; urgency=medium

  * Bump version

 -- Philippe Coval <rzr@users.sf.net>  Wed, 07 Jun 2017 14:25:51 +0200

iotivity (0.0.0-0) unstable; urgency=low

  * Initial release (Closes: #824155)

 -- Philippe Coval <rzr@gna.org>  Tue, 01 Dec 2015 23:32:27 +0000

=== debian/control ===
Source: iotivity
Priority: optional
Maintainer: Philippe Coval <rzr@gna.org>
Build-Depends: debhelper (>= 8.0.0),
 autoconf,
 automake,
 autotools-dev,
 libtool,
 libbz2-dev,
 libglib2.0-dev,
 libicu-dev,
 python-dev,
 scons,
 sudo,
 unzip,
 uuid-dev,
 libcurl4-openssl-dev | libcurl4-gnutls-dev | libcurl-ssl-dev,
 valgrind,
 libboost-thread1.55-dev | libboost-thread-dev,
 libboost-date-time1.55-dev | libboost-date-time-dev,
 libboost-iostreams1.55-dev | libboost-iostreams-dev,
 libboost-log1.55-dev | libboost-log-dev,
 libboost-program-options1.55-dev | libboost-program-options-dev,
 libboost-regex1.55-dev | libboost-regex-dev,
 libboost-system1.55-dev | libboost-system-dev,
 libsqlite3-dev
Standards-Version: 3.9.4
Section: libs
Homepage: https://iotivity.org
Vcs-Git: https://github.com/iotivity/iotivity
Vcs-Browser: http://gerrit.iotivity.org/iotivity

Package: iotivity-dev
Section: libdevel
Architecture: any
Depends: iotivity0 (= ${binary:Version})
Description: IoTivity development files
 <insert long description, indented with spaces>

Package: iotivity0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: IoTivity libraries and tools
 <insert long description, indented with spaces>

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
V=1

default: rule/debuild

%:
	dh $@


version?=$(shell [ -r debian/changelog ] && dpkg-parsechangelog | grep "Version:" | sed -e "s/Version: \(.*\)-.*/\1/g" )
tarball?=${CURDIR}/../iotivity_${version}.orig.tar.xz

rule/debuild: ${tarball}
	debuild

${tarball}: ${CURDIR}
	cd .. && tar cvfJ \
 $@ \
 --exclude 'debian' --exclude-vcs \
 ${<F}/

=== debian/watch ===
version=3
https://www.iotivity.org/downloads iotivity-(.*)\.tar\.gz
